<template>
  <b-container>
    <div class="background_bloc" />
    <h1 class="title">
      Recherche
    </h1>
  </b-container>
  <b-container>
    <b-tabs content-class="mt-3">
      <b-tab
        title="PRODUITS"
        active
      >
        <b-row v-if="produits.length">
          <b-col 
            v-for="(produit, index) in produits"
            :key="produit"
            sm="12"
            md="4"
          >
            <NomVendeur :id="produit.vendeur.id" />
            <CardProduit
              :id="produit.id"
              :id-vendeur="produit.vendeur.id"
              :titre="produit.titre"
              :prix="produit.prix"
              :image="images[index]"
            />
          </b-col>
          <button
            v-if="currentPage < nbTotalPages"
            class="btn-cta load-more"
            :data-page="currentPage"
            @click="loadMore()"
          >
            Charger plus
          </button>
        </b-row>        
        <p v-else>
          Il n'y a pas de produit associé à cette recherche.
        </p>
      </b-tab>
      <b-tab title="VENDEURS">
        <b-row v-if="vendeurs.length">
          <b-col 
            v-for="vendeur in vendeurs"
            :key="vendeur"
            sm="12"
            md="4"
          >
            <NomVendeur :id="vendeur.id" />
          </b-col>
          <button
            v-if="currentPageVendeur < nbTotalPagesVendeur"
            class="btn-cta load-more"
            :data-page="currentPageVendeur"
            @click="loadMoreVendeur()"
          >
            Charger plus
          </button>
        </b-row>        
        <p v-else>
          Il n'y a pas de vendeur associé à cette recherche.
        </p>
      </b-tab>
    </b-tabs>
  </b-container>
</template>

<script>
import { useStore } from '@/store/store';
import axios from 'axios';
import CardProduit from '@/components/CardProduit.vue'
import NomVendeur from '@/components/NomVendeur.vue'



export default {

    components: {
      NomVendeur,
      CardProduit
    },
    
    data() {;
        const store = useStore();
        const url = process.env.VUE_APP_URL;


        return {
            url,
            store,
            produits: [],
            categorie: '',
            images: [],
            nbTotalPages: '',
            currentPage: '1',
            nbTotalPagesVendeur: '',
            currentPageVendeur: '1',
            vendeurs: []
        }
    },

    watch: {
        '$route.params.val': function () {
            this.loadData();
        },
    },

    mounted() {
        this.loadData();
    },

    methods: {
        loadData(){
            this.produits = [];
            this.images = [];
            axios({
                method: 'get',
                url: this.url + "/api/produits?order[id]=desc&titre=" + this.$route.params.val,
            })
            .then(res =>  {
                let arr = res.data['hydra:member'];
                if(res.data['hydra:totalItems'] > 15){
                    this.nbTotalPages = Math.ceil(res.data['hydra:totalItems'] / 15);
                }
                for (let i = 0; i < arr.length; i++) {
                const produit = arr[i];
                if(produit.mediaObjects[0] == undefined){
                    this.images.push('noimg');
                } else {
                    this.images.push(produit.mediaObjects[0].contentUrl);
                }
                this.produits.push(produit);
                }
            })
            .catch(err => {
                console.log(err);
            });

            axios({
                method: 'get',
                url: this.url + "/api/info_vendeurs?utilisateur_id.pseudo=" + this.$route.params.val,
            })
            .then(res =>  {
                let arr = res.data['hydra:member'];
                if(res.data['hydra:totalItems'] > 15){
                    this.nbTotalPages = Math.ceil(res.data['hydra:totalItems'] / 15);
                }
                for (let i = 0; i < arr.length; i++) {
                const vendeur = arr[i];
                this.vendeurs.push(vendeur);
                }
            })
            .catch(err => {
                console.log(err);
            });
        },

        loadMore(){
            this.currentPage = parseInt(this.currentPage) + 1;
            axios.get(this.url + "/api/produits?order[id]=desc&page=" + this.currentPage + "titre=" + this.$route.params.val)
            .then(res => {
                let arr = res.data['hydra:member'];
                for (let i = 0; i < arr.length; i++) {
                    const produit = arr[i];
                    if(produit.mediaObjects[0] == undefined){
                        this.images.push('noimg');
                    } else {
                        this.images.push(produit.mediaObjects[0].contentUrl);
                    }
                    this.produits.push(produit);
                }
            })
        },

        loadMoreVendeur(){
            this.currentPageVendeur = parseInt(this.currentPageVendeur) + 1;
            axios.get(this.url + "/api/info_vendeurs?page=" + this.currentPageVendeur + "titre=" + this.$route.params.val)
            .then(res => {
                let arr = res.data['hydra:member'];
                for (let i = 0; i < arr.length; i++) {
                    const vendeur = arr[i];
                    this.vendeurs.push(vendeur);
                }
            })
        }
    }

}
</script>
